CREATE OR REPLACE FUNCTION RESULT_CACHE_ON (in_cust_id sh.customers.cust_id%type,  in_prod_id sh.sales.prod_id%type)
RETURN number 
RESULT_CACHE --RELIES_ON (SH.CUSTOMERS, SH.SALES)
authid definer
AS
 sales number(7,0);
BEGIN
select count(*) nbr_sales  into sales
 from sh.customers cust join sh.sales sales
      on cust.cust_id = sales.cust_id
 where cust.cust_id = in_cust_id
  and  prod_id = in_prod_id;
 return sales;
EXCEPTION
  when no_data_found then return 0;
END RESULT_CACHE_ON;
/